"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = __importDefault(require("chalk"));
const child_process_1 = require("child_process");
const variables_manager_1 = require("../../managers/variables-manager");
const testing_1 = require("../../testing");
class ShExec {
    #tmpFile;
    logger;
    script;
    bin = '/bin/sh';
    async init(props) {
        if (typeof props === 'string') {
            this.script = props;
        }
        else {
            Object.assign(this, props);
        }
        this.#tmpFile = new testing_1.TmpFile();
    }
    async exec() {
        try {
            this.logger.debugBlock(true);
            await this.#tmpFile.create(this.script);
            const rs = await new Promise((resolve, reject) => {
                (0, child_process_1.execFile)(this.bin, [this.#tmpFile.file], { env: process.env, cwd: variables_manager_1.GlobalUtils.curDir }, (err, stdout, stderr) => {
                    if (err)
                        return reject(err);
                    stdout && this.logger.debug(chalk_1.default.gray(stdout));
                    stderr && this.logger.debug(chalk_1.default.red(stderr));
                    resolve((stdout + '\r\n' + stderr).trim());
                });
            });
            return rs;
        }
        finally {
            this.logger.debugBlock(false);
        }
    }
    async dispose() {
        this.#tmpFile.remove();
    }
}
exports.default = ShExec;
//# sourceMappingURL=sh.js.map